#ifndef SUDOKU_HPP
#define SUDOKU_HPP

#include <string>
#include <vector>

class Sudoku {
public:
    Sudoku(void);
    std::vector< std::vector<int> > board;
    void FillBoard(std::string filePath);
    void Solve(void);
    bool IsBoardSolved(void);
    void Print(void);
    void RawPrint(void);
private:
    bool _Solve(void);
    bool FindEmptyCell(int& row, int& column);
    std::vector<int> GetUnusedRow(const int& row);
    std::vector<int> GetUnusedColumn(const int& column);
    std::vector<int> GetUnusedSubgrid(const int& row, const int& column);
};

void TrimPossiblities(std::vector<int>& possibilities);

#endif
